CREATE TABLE tx_igcrmtimerecording_domain_model_time (
	tenant_id int(11),
	employee_id int(11) NOT NULL,
	start_date datetime DEFAULT NULL,
	duration int(11) NOT NULL DEFAULT '0',
	description text,
	contact_id int(11),
	offer_id int(11),
	workflow_id int(11),
	is_changed smallint(1) unsigned NOT NULL DEFAULT '0',
	orig_start_date datetime DEFAULT NULL,
	orig_duration int(11) NOT NULL DEFAULT '0',
	activity int(11) unsigned DEFAULT '0'
);

CREATE TABLE tx_igcrmtimerecording_domain_model_activity (
	tenant_id int(11),
	active smallint(1) unsigned NOT NULL DEFAULT '0',
	name varchar(255) NOT NULL DEFAULT '',
	amount varchar(255) NOT NULL DEFAULT '',
	is_internal smallint(1) unsigned NOT NULL DEFAULT '0',
	internal_purpose int(11),
	is_default smallint(1) unsigned NOT NULL DEFAULT '0',
	activity_group int(11) unsigned DEFAULT '0'
);

CREATE TABLE tx_igcrmtimerecording_domain_model_activitygroup (
	tenant_id int(11),
	name varchar(255) NOT NULL DEFAULT ''
);
CREATE TABLE tx_igcrmtimerecording_domain_model_holiday (
	tenant_id int(11) NOT NULL DEFAULT '0',
	date date DEFAULT NULL,
	name varchar(255) NOT NULL DEFAULT ''
);



CREATE TABLE tx_igcrmtimerecording_domain_model_employee (
        frontend_user int(11) NOT NULL,
        contact_id int(11),
	active smallint(1) unsigned NOT NULL DEFAULT '0',
	last_name varchar(255),
	first_name varchar(255),
	short_name varchar(60),
	street varchar(255),
	street_nr varchar(60),
	zip varchar(60),
	city varchar(60),
	country_iso_code varchar(60),
	email varchar(255),
	phone varchar(30),
	mobile varchar(30),
	zpv varchar(60),
	place_of_origin varchar(60),
	birthday date,
	business_phone varchar(60),
	business_phone_url varchar(255),
	business_email varchar(60),
	job_title varchar(255),
	gender varchar(1),
	title varchar(40),
	signature varchar(255),
	salary double(11,2),
	time_carryover int(11) NOT NULL DEFAULT '0',
	holiday_carryover double(11,2) NOT NULL DEFAULT '0.00',
	employment_in_percent int(11) NOT NULL DEFAULT '0',
	holiday_days_in_year int(11) NOT NULL DEFAULT '0',
	entry_date date DEFAULT NULL,
	exit_date date DEFAULT NULL,
	bvg double(11,2),
	quellensteuer double(11,2),
	no_nbuv smallint(1) unsigned NOT NULL DEFAULT '0',
	salary13_active smallint(1) unsigned NOT NULL DEFAULT '0',
	salary13_extra double(11,2),
	salary13_month int(11),
	commission_amount double(11,2) NOT NULL DEFAULT '0',
	commission_text varchar(255),
	correction_amount double(11,2) NOT NULL DEFAULT '0',
	correction_text varchar(255),
	number_of_children int(11) NOT NULL DEFAULT '0',
	ahv_mandatory smallint(1) unsigned NOT NULL DEFAULT '0',
	hourly_wage double(11,2),
	bank_account varchar(255)
);
